// Generated by CoffeeScript 1.6.3
(function() {
  exports.getEmbeddedJS = function(labels) {
    var embedded, k, scope, v;
    scope = module.exports.setClientScope({}, labels);
    embedded = "\n<![CDATA[\n";
    embedded += "var scope = mapReporting = {";
    for (k in scope) {
      v = scope[k];
      embedded += "\n" + k + " : ";
      embedded += (v != null) && typeof v === "function" ? v.toString() : (v != null) && typeof v === "object" ? JSON.stringify(v) : null;
      embedded += ",";
    }
    return embedded += "};\n]]>";
  };

  exports.setClientScope = function(scope, labels) {
    scope.usingAlternateColor = false;
    scope.labels = labels;
    scope.removeClass = function(element, name) {
      return element.setAttribute("class", element.getAttribute("class").split(" ").filter(function(a) {
        return a !== name;
      }).join(" "));
    };
    scope.removeAllClass = function(name) {
      var selected, _i, _len, _ref, _results;
      _ref = document.getElementsByClassName(name);
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        selected = _ref[_i];
        _results.push(this.removeClass(selected, name));
      }
      return _results;
    };
    scope.addClass = function(element, name) {
      var arr;
      arr = element.getAttribute("class").split(" ");
      arr.push(name);
      return element.setAttribute("class", arr.join(" "));
    };
    scope.hasClass = function(element, name) {
      return (element.getAttribute("class").split(" ")).indexOf(name) >= 0;
    };
    scope.somethingIsSelected = function() {
      return (document.getElementsByClassName("selected")).length > 0;
    };
    scope.displayShapeInDashboard = function(shape) {
      document.getElementById("dashboardTitle").firstChild.nodeValue = shape.getAttribute("id") + " " + shape.getAttribute("name");
      document.getElementById("dashboardLink").setAttribute("xlink:href", shape.getAttribute("link").replace(/&/g, "%26"));
      document.getElementById("dashboardLink").setAttribute("href", shape.getAttribute("link").replace(/&/g, "%26"));
      document.getElementById("dashboardLinkText").firstChild.nodeValue = this.labels.link;
      return document.getElementById("dashboardSatisfaction").firstChild.nodeValue = this.labels.value + shape.getAttribute("value");
    };
    scope.emptyDashboard = function() {
      document.getElementById("dashboardTitle").firstChild.nodeValue = "Nothing selected";
      document.getElementById("dashboardLinkText").firstChild.nodeValue = "";
      return document.getElementById("dashboardSatisfaction").firstChild.nodeValue = "";
    };
    scope.displaySelected = function() {
      var selected, _i, _len, _ref, _results;
      _ref = document.getElementsByClassName("selected");
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        selected = _ref[_i];
        _results.push(this.displayShapeInDashboard(selected));
      }
      return _results;
    };
    scope.putOnTop = function(shape) {
      var id;
      document.getElementById("head").appendChild(shape);
      id = document.getElementById("id" + shape.getAttribute("id"));
      if (id != null) {
        return document.getElementById("head").appendChild(id);
      }
    };
    scope.putSelectedOnTop = function() {
      var selected, _i, _len, _ref, _results;
      _ref = document.getElementsByClassName("selected");
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        selected = _ref[_i];
        _results.push(this.putOnTop(selected));
      }
      return _results;
    };
    scope.mouseOver = function(shape) {
      if (!this.hasClass(shape, "selected")) {
        this.addClass(shape, "hovered");
      }
      this.putOnTop(shape);
      this.putSelectedOnTop();
      return this.displayShapeInDashboard(shape);
    };
    scope.mouseOut = function(shape) {
      this.removeClass(shape, "hovered");
      if (this.somethingIsSelected()) {
        return this.displaySelected();
      } else {
        return this.emptyDashboard();
      }
    };
    scope.mouseDown = function(shape) {
      var isSelected;
      isSelected = this.hasClass(shape, "selected");
      this.removeAllClass("selected");
      if (isSelected) {
        this.addClass(shape, "hovered");
      } else {
        this.removeClass(shape, "hovered");
        this.addClass(shape, "selected");
      }
      return this.putOnTop(shape);
    };
    scope.shapeOver = function(evt) {
      return this.mouseOver(evt.target);
    };
    scope.shapeOut = function(evt) {
      return this.mouseOut(evt.target);
    };
    scope.shapeDown = function(evt) {
      return this.mouseDown(evt.target);
    };
    scope.IDover = function(evt) {
      return this.mouseOver(document.getElementById(evt.target.getAttribute("id").slice(2)));
    };
    scope.IDout = function(evt) {
      return this.mouseOut(document.getElementById(evt.target.getAttribute("id").slice(2)));
    };
    scope.IDdown = function(evt) {
      return this.mouseDown(document.getElementById(evt.target.getAttribute("id").slice(2)));
    };
    scope.changeScaleColor = function(evt) {
      var element, elements, _i, _len;
      elements = document.getElementsByClassName("good");
      for (_i = 0, _len = elements.length; _i < _len; _i++) {
        element = elements[_i];
        if (this.usingAlternateColor) {
          element.setAttribute("fill", "url(#" + element.getAttribute("initialFilter") + ")");
          element.setAttribute("stroke", element.getAttribute("initialColor"));
        } else {
          element.setAttribute("fill", "url(#" + element.getAttribute("alternateFilter") + ")");
          element.setAttribute("stroke", element.getAttribute("alternateColor"));
        }
      }
      return this.usingAlternateColor = !this.usingAlternateColor;
    };
    return scope;
  };

}).call(this);
